/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.ow2.petals.se.script;

import groovy.lang.GroovyClassLoader;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import org.codehaus.groovy.control.CompilationFailedException;

/**
 * @author Christophe HAMERLING (chamerling) - eBM WebSourcing
 * 
 */
public class ScriptContext {

    private Map<String, JBIScript> scriptInstance;

    /**
     * Creates a new instance of {@link ScriptContext}
     * 
     */
    public ScriptContext() {
        this.scriptInstance = new HashMap<String, JBIScript>();
    }

    /**
     * 
     * @param suName
     * @param instance
     */
    public void addScriptInstance(String suName, JBIScript instance) {
        this.scriptInstance.put(suName, instance);
    }

    /**
     * 
     * @param suName
     * @return
     */
    public JBIScript getScriptInstance(String suName) {
        return this.scriptInstance.get(suName);
    }

    /**
     * 
     * @param scriptFile
     * @return
     */
    public JBIScript loadScriptInstance(File scriptFile) {
        JBIScript result = null;
        try {
            GroovyClassLoader gcl = new GroovyClassLoader(getClass().getClassLoader());
            Class<?> clazz = gcl.parseClass(scriptFile);
            Object o = clazz.newInstance();
            result = (JBIScript) o;
        } catch (CompilationFailedException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (InstantiationException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IllegalAccessException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return result;
    }
}
