/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.ow2.petals.se.script;

import javax.jbi.JBIException;

import org.ow2.petals.component.framework.se.AbstractServiceEngine;

/**
 * @author Christophe HAMERLING (chamerling) - eBM WebSourcing
 * 
 */
public class ScriptEngine extends AbstractServiceEngine {

    private ScriptContext scriptContext;

    /**
     * Creates a new instance of {@link ScriptEngine}
     * 
     */
    public ScriptEngine() {
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.petals.component.framework.AbstractComponent#doInit()
     */
    @Override
    protected void doInit() throws JBIException {
        if (this.scriptContext == null) {
            this.scriptContext = new ScriptContext();
        }
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.petals.component.framework.AbstractComponent#doStart()
     */
    @Override
    protected void doStart() throws JBIException {
        ScriptSUListener suListener = new ScriptSUListener(scriptContext);
        this.setServiceUnitListener(suListener);
    }

    /**
     * @return the scriptContext
     */
    public ScriptContext getScriptContext() {
        return this.scriptContext;
    }
}
